package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type plan struct {
	Tables
	schedule schedule
	create   string `name:"create reception_uid*:select volume_uid*:select" role:"void"`
	cancel   string `name:"cancel" role:"void"`
}

func (s plan) Create(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.Create, arg, m.OptionSimple(model.QUEUE_UID, model.USER_UID), model.STATUS, SchedulePlan)
}
func (s plan) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		m.Cmdy(s.schedule, s.schedule.SelectByStatus, arg[0], SchedulePlan, m.OptionSimple(model.USER_UID)).PushAction(s.Cancel)
		kit.If(m.Length() == 0, func() { m.EchoInfoButton(m.Trans("please create schedule", "请创建预约"), s.Create) }, func() { m.Action(s.Create) })
	} else if len(arg) == 2 {
		m.FieldsSetDetail()
		m.Cmdy(s.schedule, s.schedule.SelectByStatus, arg[0], SchedulePlan, m.OptionSimple(model.USER_UID), s.Key(s.schedule, model.UID), arg[1]).PushAction(s.Cancel)
	}
}
func (s plan) Cancel(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.Cancel)
}

func init() { ice.TeamCtxCmd(plan{}) }
