package yuehaoxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type userQueue struct {
	Table
	queue queue
}

func (s userQueue) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.QUEUE_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.QUEUE_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_QUEUE_ROLE)
	s.SelectJoinUser(m)
	s.RewriteAppend(m)
}
func (s userQueue) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.queue).FieldsWithCreatedAT(m, s,
		model.QUEUE_NAME, model.QUEUE_TYPE, model.USER_QUEUE_ROLE,
		model.COMPANY_UID, model.QUEUE_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
	s.RewriteAppend(m)
}

func init() { ice.TeamCtxCmd(userQueue{Table: newTable()}) }

type UserQueueRole int

const (
	UserQueueCreator UserQueueRole = iota
	UserQueueVisitor
	UserQueueManager
	UserQueueWorker
	UserQueueWaiter
)

var UserQueueRoleList = map[UserQueueRole]string{
	UserQueueCreator: "creator",
	UserQueueVisitor: "visitor",
	UserQueueManager: "manager",
	UserQueueWorker:  "worker",
	UserQueueWaiter:  "waiter",
}

func (s UserQueueRole) String() string { return UserQueueRoleList[s] }
